#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "partSys.h"
#include <strings.h>
#include <assert.h>

#define DEBUG 0  // for function names
partSys::partSys(){
	partSys(50, 200);
};


partSys::partSys(int new_rate, int new_default_life){

		this->cr = 1; this->cg =.2; this->cb = .5;	
		this->num_part = new_rate * (3+new_default_life);
    	if(DEBUG ==1)printf("in constructor number of particle sis %d * %d = %d\n",new_rate,new_default_life,this->num_part);
		this->num_alive = 0;
		this->num_dead = this->num_part;
		Plist = new Particle*[num_part];
		this->dt = 1;	
		
    	if(DEBUG)printf("num_dead = num_part = %d or %d\n",this->num_dead, this->num_part);
		this->rate = new_rate;
		if(DEBUG)printf("this->rate %d\n",this->rate);
	
		this->default_life = new_default_life;
		if(DEBUG)printf("life set to %d, should be %d\n",this->default_life, new_default_life);
		for(int i = 0; i < num_part; i ++){
			Particle *tmp = new Particle();
			Plist[i] = tmp; 

		}
		this->ivv = 0.0;
		this->scale = 1;
		this->default_strength = 1;
		
};


float partSys::get_value_atv(float pos[3]){
	float q = 0, p = 0;
	//for each Particle 
	
	//retuRn sqrt((pow(pos[0],2) + pow(pos[1],2) + pow(pos[2],2)))/25;
	
	for(int i = 0; i < num_part; i++){
		q += pow(Plist[i]->strength,2) / ( 
		          pow((pos[0] - Plist[i]->pos[0]),2) + 
				  pow((pos[1] - Plist[i]->pos[1]),2) +
				  pow((pos[2] - Plist[i]->pos[2]),2));

	}

	
	return q >0  && q < MAXFLOAT ? q : 0 ;
}
void partSys::update(){

	emit(); // emit some particles, done at end to avoid core dumps ;
	/* this is the meaty function that updates the position of all the
	 * particles... need to figure out some way of making it go fast */

    if(DEBUG == 1)printf("num_p at start of update is %d\n",num_part);
	for(int i = 0; i < num_part; i++){
	
		// run runge kutta on each particle ? excessive? lets just do euler for
		// now, maybe figure out the next velocity using rk4 or somethign

    	if(DEBUG==1)printf("life of %d is %d\n",i,Plist[i]->ttd);	
		if(Plist[i]->ttd < 2 ){
            if(!Plist[i]->dead){
				Plist[i]->dead = 1;
				// if this is the particle's last frame of life, don't update
				// it, but mark it as dead
    			num_dead++; // increment last_dead to say that there are more
	   		  	num_alive--;					//particles availiable
			
			    if(DEBUG == 1 ) printf("killing particle %d\n",i);	

			}
		}else if(Plist[i]->ttd > 1){
			Plist[i]->ttd = (float) Plist[i]->ttd - 1;
			Plist[i]->pos[0] += scale * dt * Plist[i]->vel[0] + .5 * ax * pow(dt,2)  ;
			Plist[i]->pos[1] += scale * dt * Plist[i]->vel[1] + .5 * ay * pow(dt,2)  ;
			Plist[i]->pos[2] += scale * dt * Plist[i]->vel[2] + .5 * az * pow(dt,2)  ;
	
			Plist[i]->vel[0] += scale * dt * ax;
			Plist[i]->vel[1] += scale * dt * ay;
			Plist[i]->vel[2] += scale * dt * az;
		}
	} 

	if(DEBUG)printf("this-rate = %d\n",this->rate);
    
	
    if(DEBUG==1)printf("num_p at end of update is %d\n",num_part);
}

void partSys::emit(){

    if(DEBUG)printf("num_p at start of Emit is %d\n",num_part);
    int n = this->rate;
	int p; // a particle to point to, used later
	if(this->num_dead < this->rate){

		printf("almost out of particles \n");
		n = this->num_dead;
	}
	
    if(DEBUG == 1)	printf("emiting %d\n",n);
	while(n > 0){
		//emit n particles
		n--;
		p = -1;
		for(int i = 0; i < num_part;i++){
		//scan the particle array for a dead particle
			if(this->Plist[i]->dead > 0){
    			p = i;
				break; // out of for loop
				
			};
			
			
		};
		

		if(p < 0){
			printf("no particles\n");
			break; // out of while
		}else {
			// emit the particle by reseting its life and position and
			// velocity
            if(DEBUG==1)printf("Making %d\n",p);
			this->num_alive++;
			this->num_dead--;
			this->Plist[p]->ttd = this->default_life;
			if(DEBUG >1)printf("life set to %f,%d \n",this->Plist[p]->ttd,this->default_life);
		    this->Plist[p]->dead = 0;
			
			this->Plist[p]->pos[0] = this->emmiter_pos[0];	
			this->Plist[p]->pos[1] = this->emmiter_pos[1];	
			this->Plist[p]->pos[2] = this->emmiter_pos[2];	
		srand48(p + (int)Plist[p]->pos[0] + num_alive);		
			this->Plist[p]->vel[0] = scale * initial_vector[0] + ivv* (float)(.5 - drand48());
			this->Plist[p]->vel[1] = scale * initial_vector[1]+ ivv * (float)(.5 - drand48());
			this->Plist[p]->vel[2] = scale * initial_vector[2]+ ivv * (float)(.5 - drand48());

		if(DEBUG > 0)printf("(in emit())Plist[%d] at (%f,%f,%f) -> (%f,%f,%f)\n",p,Plist[p]->pos[0],Plist[p]->pos[1],Plist[p]->pos[2],Plist[p]->vel[0],Plist[p]->vel[1],Plist[p]->vel[2]);
			this->Plist[p]->strength = default_strength *(1 - pow(.5 -
			drand48(),2));
		
		}
		
	}
if(DEBUG)	
    printf("num_p at end of Emit is %d\n",num_part);
};
void partSys::drawIt(){
	if(DEBUG >1){
	
	printf("emmitter at (%2f,%2f,%2f) -> (%f,%f,%f)\n",emmiter_pos[0], emmiter_pos[1], emmiter_pos[2],initial_vector[0],initial_vector[1],initial_vector[2]);
}
glPushMatrix();
	glBegin(GL_LINES);

	
		if(DEBUG ==1) printf("drawing %d particles \n",this->num_part);
	glVertex3f(emmiter_pos[0]-(scale * 1), emmiter_pos[1] - (scale * 1), emmiter_pos[2]);
	glVertex3f(emmiter_pos[0]+(scale * 1), emmiter_pos[1] + (scale * 1), emmiter_pos[2]);
	glVertex3f(emmiter_pos[0]+(scale * 1), emmiter_pos[1] - (scale * 1), emmiter_pos[2]);
	glVertex3f(emmiter_pos[0]-(scale * 1), emmiter_pos[1] + (scale * 1), emmiter_pos[2]);


	glVertex3fv(emmiter_pos);
	glVertex3f(emmiter_pos[0] + scale *2*
	initial_vector[0],emmiter_pos[1] + scale *2*
	initial_vector[1],emmiter_pos[2] + scale *2* initial_vector[2]);
	glEnd();

	
			
			glBegin(GL_POINTS);
	for(int i = 0; i < num_part; i++){
		if(!this->Plist[i]->dead){ // if alive
			
		if(DEBUG ==1)	printf("p[%d] at (%f,%f,%f) -> (%f,%f,%f)\n",i,Plist[i]->pos[0],Plist[i]->pos[1],Plist[i]->pos[2],Plist[i]->vel[0],Plist[i]->vel[1],Plist[i]->vel[2]);
	
			glPointSize(2 * Plist[i]->strength);	
			glColor3f(cr,cg,cb);
			glVertex3f(Plist[i]->pos[0], Plist[i]->pos[1],Plist[i]->pos[2]);
			glVertex3f(0,0,0);	

		}	
	}
	glEnd();


glPopMatrix();	

}

